#!/usr/bin/env python


def main(source_category, surface_relation, target_category):
    phrase_file = '/home/ndapa/evidence/data/svo/typed_hazy/typed_phrases.tsv'
    triples_file = '/home/ndapa/evidence/data/svo/typed_hazy/typed_triples.tsv'
    if surface_relation:
        print 'Looking for phrase id'
        phrase_id = None
    else:
        print 'Looking for possible relations'
        possible_relations = []
    i = 0
    for line in open(phrase_file):
        i += 1
        if i % 100000 == 0:
            print i
        fields = line.strip().split('\t')
        if (fields[1] == source_category and
                fields[3] == target_category):
            if not surface_relation:
                possible_relations.append((fields[2], i))
                continue
            if fields[2] == surface_relation:
                phrase_id = fields[0]
                break
    if not surface_relation:
        print 'Acceptable relations:'
        for r in possible_relations:
            print ' ', r
        return
    if not phrase_id:
        print 'Phrase not found!'
        return
    print 'Phrase id is', phrase_id
    triples = []
    i = 0
    print 'Looking for matching triples'
    for line in open(triples_file):
        i += 1
        if i % 100000 == 0:
            print i
        fields = line.strip().split('\t', 4)
        phrase_ids = fields[4].split('\t')
        if phrase_id in phrase_ids:
            triples.append((int(fields[0]), fields[1], fields[3]))
    triples.sort()
    print triples


if __name__ == '__main__':
    from optparse import OptionParser
    parser = OptionParser()
    parser.add_option('-s', '--source',
                      dest='source',
                      help='Category of source node',
                      )
    parser.add_option('-t', '--target',
                      dest='target',
                      help='Category of target node',
                      )
    parser.add_option('-r', '--relation',
                      dest='relation',
                      help='Surface relation',
                      )
    opts, args = parser.parse_args()
    main(opts.source, opts.relation, opts.target)

# vim: et sw=4 sts=4
