#!/usr/bin/env python

from counter import Index
from dirutil import try_makedirs

import os

def make_to_ignore(base_dir):
    edge_ids = Index.read_from_file(open(base_dir + 'edge_dict.tsv'))
    inverses = {}
    out = open(base_dir + 'inverses_ids.tsv', 'w')
    for line in open(base_dir + 'inverses.tsv'):
        rel, inv = line.strip().split('\t')
        inverses[rel] = inv
        rel_id = edge_ids.getIndex(rel)
        inv_id = edge_ids.getIndex(inv)
        out.write('%d\t%d\n' % (rel_id, inv_id))
    try_makedirs(base_dir + 'to_ignore/')
    for root, dirs, files in os.walk(base_dir + 'relations'):
        for f in files:
            relation = f.split('_')[0]
            to_ignore_filename = base_dir + 'to_ignore/' + relation
            to_ignore = open(to_ignore_filename, 'w')
            to_ignore.write(str(edge_ids.getIndex(relation)) + '\n')
            to_ignore.write(str(edge_ids.getIndex(inverses[relation])) + '\n')
            to_ignore.close()


def main():
    from optparse import OptionParser
    parser = OptionParser()
    parser.add_option('-b', '--base',
            dest='base',
            help='Base directory to get data files from',
            )
    opts, args = parser.parse_args()
    make_to_ignore(opts.base)


if __name__ == '__main__':
    main()

# vim: et sw=4 sts=4
