#!/usr/bin/env python

from counter import Index

def main(matrix_file, path_file, node_dict_file):
    node_dict = Index.read_from_file(open(node_dict_file))
    paths = []
    for line in open(path_file):
        paths.append(line.split('\t')[0])
    outfile = matrix_file + '.translated'
    out = open(outfile, 'w')
    for line in open(matrix_file):
        pair, path_pairs = line[:-1].split('\t')
        source, target = pair.split(',')
        path_pairs = path_pairs.split(' -#- ')[:-1]
        for path in path_pairs:
            path_id, path_prob = path.split(',')
            translated = []
            translated.append(node_dict.getString(int(source)))
            translated.append(node_dict.getString(int(target)))
            translated.append(paths[int(path_id)])
            translated.append(path_prob)
            out.write('\t'.join(translated) + '\n')
    out.close()


if __name__ == '__main__':
    import sys
    if len(sys.argv) != 4:
        print 'Usage:', sys.argv[0], '[matrix_file] [path_file] [node_dict]'
        exit(-1)
    main(sys.argv[1], sys.argv[2], sys.argv[3])

# vim: et sw=4 sts=4
