#!/usr/bin/env python

from counter import Index
from collections import defaultdict

def main(path_file, edge_id_file):
    inverses = {}
    for line in open(edge_id_file.replace('edge_dict', 'inverses')):
        rel, inv = line.strip().split('\t')
        # Here we keep whichever relation shows up first as the one to collapse
        # to
        if inv not in inverses:
            inverses[rel] = inv
    index = Index.read_from_file(open(edge_id_file))
    counts = defaultdict(int)
    for line in open(path_file):
        path, count = line.strip().split('\t')
        edges = path.split('-')
        translated = []
        for edge in edges:
            if not edge:
                continue
            reverse = False
            if edge[0] == '_':
                reverse = True
                edge = edge[1:]
            try:
                edge = index.getString(int(edge))
            except IndexError:
                print line, int(edge), index.current_index
                raise
            if edge in inverses:
                edge = inverses[edge]
                reverse = not reverse
            if reverse:
                edge = '_' + edge
            translated.append(edge)
        new_path = '-'+'-'.join(translated) + '-'
        counts[new_path] += int(count)
    paths = counts.keys()
    paths.sort(key=lambda x: counts[x], reverse=True)
    outfile = path_file + '.translated'
    out = open(outfile, 'w')
    for path in paths:
        out.write('%s\t%d\n' % (path, counts[path]))
    out.close()
    outfile = path_file + '.collapsed'
    out = open(outfile, 'w')
    for path in paths:
        translated = []
        for edge in path.split('-'):
            reverse = False
            if not edge: continue
            if edge[0] == '_':
                reverse = True
                edge = edge[1:]
            edge = str(index.getIndex(edge))
            if reverse:
                edge = '_' + edge
            translated.append(edge)
        new_path = '-'+'-'.join(translated) + '-'
        out.write('%s\t%d\n' % (new_path, counts[path]))
    out.close()


if __name__ == '__main__':
    import sys
    if len(sys.argv) != 3:
        print 'Usage:', sys.argv[0], '[path_file] [edge_ids]'
        exit(-1)
    main(sys.argv[1], sys.argv[2])

# vim: et sw=4 sts=4
