#!/usr/bin/env python

from counter import Index
from collections import defaultdict

def main(weight_file, edge_id_file):
    index = Index.read_from_file(open(edge_id_file))
    weights = []
    for line in open(weight_file):
        path, weight = line.strip().split('\t')
        edges = path.split('-')
        translated = []
        for edge in edges:
            if not edge:
                continue
            reverse = False
            if edge[0] == '_':
                reverse = True
                edge = edge[1:]
            try:
                edge = index.getString(int(edge))
            except IndexError:
                print line, int(edge), index.current_index
                raise
            if reverse:
                edge = '_' + edge
            translated.append(edge)
        new_path = '-'+'-'.join(translated) + '-'
        weights.append((float(weight), new_path))
    weights.sort(reverse=True)
    outfile = weight_file + '.translated'
    out = open(outfile, 'w')
    for weight, path in weights:
        out.write('%s\t%f\n' % (path, weight))
    out.close()


if __name__ == '__main__':
    import sys
    if len(sys.argv) != 3:
        print 'Usage:', sys.argv[0], '[weight_file] [edge_ids]'
        exit(-1)
    main(sys.argv[1], sys.argv[2])

# vim: et sw=4 sts=4
